
import java.util.*;
import java.awt.geom.*;

public abstract class PointList2D {
	public PointList2D() {
	}

	// Einfgen/Lschen/Finden eines Punktes
	public abstract void insert(Point2D.Double point);
	public abstract boolean remove(Point2D.Double point);
	public abstract boolean contains(Point2D.Double point);

	// Listet alle Punkte auf, die sich im angegebenen Bereich befinden
	public abstract ArrayList findInRangeX(double xFrom, double xTo);
	public abstract ArrayList findInRangeY(double yFrom, double yTo);

	// Listet alle Punkte auf, die sich in diesem Rechteck befinden
	public abstract ArrayList findInRectangle(Rectangle2D.Double rect);

	// Sucht den am nchsten stehenden Punkt (sqrt(dx+dy) = Minimum)
	public abstract Point2D.Double findNearest(Point2D.Double point);

	// Ausgabe aller Punkte (zum Testen)
	public abstract void printAll();
}
